import { Label } from "./parse-domain";
import { NO_HOSTNAME } from "./from-url";
export declare enum ValidationErrorType {
    NoHostname = "NO_HOSTNAME",
    DomainMaxLength = "DOMAIN_MAX_LENGTH",
    LabelMinLength = "LABEL_MIN_LENGTH",
    LabelMaxLength = "LABEL_MAX_LENGTH",
    LabelInvalidCharacter = "LABEL_INVALID_CHARACTER"
}
export declare type ValidationError = {
    type: ValidationErrorType;
    message: string;
    column: number;
};
export declare enum SanitizationResultType {
    Ok = "OK",
    Error = "ERROR"
}
export declare type SanitizationResultOk = {
    type: SanitizationResultType.Ok;
    originalInput: string;
    labels: Array<Label>;
};
export declare type SanitizationResultError = {
    type: SanitizationResultType.Error;
    originalInput: string | unknown;
    errors: Array<ValidationError>;
};
export declare type SanitizationResult = SanitizationResultOk | SanitizationResultError;
export declare const sanitize: (input: string | typeof NO_HOSTNAME) => SanitizationResult;
